package model;

import java.util.ArrayList;

public class Giant extends Piece{
    protected Giant(Position p, int color) {
        super(p, color);
    }


    @Override
    public ArrayList<Position> getAvailableMoves(Board b) {

        ArrayList<Position> moves = new ArrayList<>();

        Position arrival;
        int i = 1;
        boolean left = false;
        boolean right = false;
        boolean top = false;
        boolean down = false;

        while (i < 4) {

            //left

            arrival = new Position(p.getX() + (i*2), p.getY());
            if (arrival.isCorrect()) {
                if (!left) {
                    if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
                        moves.add(arrival);
                    }

                    if (b.isKing(arrival)) {
                        moves.add(arrival);

                    }
                }
                if (!b.isFree(arrival)) {
                    left = true;
                }
            }

            //right
            arrival = new Position(p.getX() - (i*2), p.getY());
            if (arrival.isCorrect()) {
                if (!right) {
                    if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
                        moves.add(arrival);
                    }
                    if (b.isKing(arrival)) {
                        moves.add(arrival);
                    }
                }

                if (!b.isFree(arrival)) {

                    right = true;
                }
            }


            arrival = new Position(p.getX(), p.getY() + (i*2));
            if (arrival.isCorrect()) {
                if (!top) {
                    if (b.isEnemy(arrival, p)|| b.isFree(arrival)) {
                        moves.add(arrival);
                    }
                }

                if (!b.isFree(arrival)) {

                    top = true;
                }
            }



            arrival = new Position(p.getX(), p.getY() - (i*2));
            if (arrival.isCorrect()) {
                if (!down) {
                    if (b.isEnemy(arrival, p)|| b.isFree(arrival)) {
                        moves.add(arrival);
                    }
                }

                if (!b.isFree(arrival)) {

                    top = true;
                }
            }

            i++;
        }

        return moves;

    }
}
